/*
 * IClassDefinitions.java
 *  
 * Copyright 2007 C.A. Meijer
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package com.hammingweight.hammock;

/**
 * This interface defines class instances that are used in Hammock.
 * 
 * @author C.A. Meijer
 * @since Hammock 1.0
 * 
 */
public interface IClassDefinitions {

	public static final Class OBJECT_CLASS = (new Object()).getClass();
	
	public static final Class THROWABLE_CLASS = (new Throwable()).getClass();
	
	public static final Class BOOLEAN_CLASS = (new Boolean(false)).getClass();
	
	public static final Class BYTE_CLASS = (new Byte((byte)0)).getClass();
	
	public static final Class CHARACTER_CLASS = (new Character((char)0)).getClass();
	
	public static final Class SHORT_CLASS = (new Short((short)0)).getClass();
	
	public static final Class INTEGER_CLASS = (new Integer(0)).getClass();
	
	public static final Class LONG_CLASS = (new Long(0L)).getClass();
	
	public static final Class IMOCKOBJECT_CLASS = OBJECT_CLASS;
	
}
