package com.hammingweight.hammock;

import junit.framework.TestCase;

public class PopulateArrayMatcherTest extends TestCase {

	public void testBadActualArgumentNull() {
		Object expected = new Object[3];
		PopulateArrayMatcher aam = new PopulateArrayMatcher(0, 1, 0);
		assertFalse(aam.areArgumentsEqual(expected, null));
	}
	
	public void testGoodArgument() {
		Object expected = new Object[3];
		Object actual = new Object[3];
		PopulateArrayMatcher aam = new PopulateArrayMatcher(0, 1, 0);
		assertTrue(aam.areArgumentsEqual(expected, actual));
	}
	
	public void testPopuplateArray() {
		byte[] expected = {1, 2, 4};
		byte[] actual = new byte[5];
		PopulateArrayMatcher aam = new PopulateArrayMatcher(0, 3, 0);
		assertTrue(aam.areArgumentsEqual(expected, actual));
		assertEquals(1, actual[0]);
		assertEquals(2, actual[1]);
		assertEquals(4, actual[2]);
		assertEquals(0, actual[3]);
		assertEquals(0, actual[4]);
	}
	
	public void testPopulateArrayWithSrcOffset() {
		byte[] expected = {1, 2, 4};
		byte[] actual = new byte[5];
		PopulateArrayMatcher aam = new PopulateArrayMatcher(1, 2, 0);
		assertTrue(aam.areArgumentsEqual(expected, actual));
		assertEquals(2, actual[0]);
		assertEquals(4, actual[1]);
		assertEquals(0, actual[2]);
		assertEquals(0, actual[3]);
		assertEquals(0, actual[4]);
	}
	
	public void testPopulateArrayWithDestOffset() {
		byte[] expected = {1, 2, 4};
		byte[] actual = new byte[5];
		PopulateArrayMatcher aam = new PopulateArrayMatcher(1, 2, 1);
		assertTrue(aam.areArgumentsEqual(expected, actual));
		assertEquals(0, actual[0]);
		assertEquals(2, actual[1]);
		assertEquals(4, actual[2]);
		assertEquals(0, actual[3]);
		assertEquals(0, actual[4]);
	}
	
	public void testPopulateArrayWithSubClass() {
		String[] expected = {"1", "2"};
		Object[] actual = new Object[]{new Integer(2), new Integer(1)};
		PopulateArrayMatcher aam = new PopulateArrayMatcher(0, 2, 0);
		assertTrue(aam.areArgumentsEqual(expected, actual));
	}
}
